<?php
include 'header.php';
include 'menu.php';
?>

<div class="main">
    <div class="body container">
        <?php include 'page-title.php'; ?>
        <div class="row typecho-page-main" role="main">
            <div class="col-mb-12">
                <div class="typecho-list-table">
                    <div class="typecho-option-tabs">
                        <ul class="typecho-option-tabs clearfix">
                            <li class="current"><a href="<?php $options->adminUrl('extending.php?panel=Members%2FAdmin.php'); ?>"><?php _e('会员列表'); ?></a></li>
                            <li><a href="#tab-add" id="btn-add-member"><?php _e('添加会员'); ?></a></li>
                        </ul>
                    </div>
                    
                    <!-- 添加会员表单 -->
                    <div class="typecho-edit-theme" id="form-add-member" style="display:none;">
                        <form action="<?php $security->index('/action/members-edit?do=editMember'); ?>" method="post">
                            <ul class="typecho-option">
                                <li>
                                    <label class="typecho-label" for="user-select"><?php _e('选择用户'); ?></label>
                                    <select name="uid" id="user-select" class="w-100" required>
                                        <option value=""><?php _e('请选择用户'); ?></option>
                                        <?php
                                        $db = Typecho_Db::get();
                                        $users = $db->fetchAll($db->select('uid', 'name', 'mail')
                                            ->from('table.users')
                                            ->where('group != ?', 'visitor')
                                            ->order('uid', Typecho_Db::SORT_ASC));
                                        
                                        foreach ($users as $user) {
                                            echo '<option value="' . $user['uid'] . '">' . 
                                                $user['name'] . ' (' . $user['mail'] . ')</option>';
                                        }
                                        ?>
                                    </select>
                                </li>
                                <li>
                                    <label class="typecho-label" for="start-time"><?php _e('开始时间'); ?></label>
                                    <input type="date" id="start-time" name="start_time" class="w-100 text" value="<?php echo date('Y-m-d'); ?>"/>
                                </li>
                                <li>
                                    <label class="typecho-label" for="expire-time"><?php _e('到期时间'); ?></label>
                                    <input type="date" id="expire-time" name="expire_time" class="w-100 text" required/>
                                </li>
                                <li>
                                    <button type="submit" class="btn primary"><?php _e('保存设置'); ?></button>
                                    <?php $security->nonce(); ?>
                                </li>
                            </ul>
                        </form>
                    </div>

                    <!-- 会员列表 -->
                    <div class="typecho-table-wrap">
                        <table class="typecho-list-table">
                            <colgroup>
                                <col width="20%"/>
                                <col width="20%"/>
                                <col width="20%"/>
                                <col width="20%"/>
                                <col width="20%"/>
                            </colgroup>
                            <thead>
                                <tr>
                                    <th><?php _e('用户名'); ?></th>
                                    <th><?php _e('开始时间'); ?></th>
                                    <th><?php _e('到期时间'); ?></th>
                                    <th><?php _e('状态'); ?></th>
                                    <th><?php _e('操作'); ?></th>
                                </tr>
                            </thead>
                            <tbody>
                                <?php
                                $members = Members_Plugin::getAllMembers();
                                $currentTime = time();
                                
                                if ($members): foreach ($members as $member): ?>
                                <tr id="member-<?php echo $member['uid']; ?>">
                                    <td><?php echo $member['name']; ?></td>
                                    <td><?php echo date('Y-m-d', $member['start_time']); ?></td>
                                    <td>
                                        <span class="edit-expire-time" data-uid="<?php echo $member['uid']; ?>">
                                            <?php echo date('Y-m-d', $member['expire_time']); ?>
                                        </span>
                                    </td>
                                    <td>
                                        <span class="status <?php echo $member['expire_time'] > $currentTime ? 'active' : 'expired'; ?>">
                                            <?php echo $member['expire_time'] > $currentTime ? '有效' : '已过期'; ?>
                                        </span>
                                    </td>
                                    <td>
                                        <a href="#" class="btn-edit" data-uid="<?php echo $member['uid']; ?>"><?php _e('编辑'); ?></a>
                                        <a href="<?php $security->index('/action/members-edit?do=deleteMember&uid=' . $member['uid']); ?>" 
                                           class="btn-delete" 
                                           onclick="return confirm('<?php _e('确认要删除此会员吗？'); ?>');">
                                            <?php _e('删除'); ?>
                                        </a>
                                    </td>
                                </tr>
                                <?php endforeach; else: ?>
                                <tr>
                                    <td colspan="5"><h6 class="typecho-list-table-title"><?php _e('暂无会员'); ?></h6></td>
                                </tr>
                                <?php endif; ?>
                            </tbody>
                        </table>
                    </div>

                    <!-- 编辑会员弹窗 -->
                    <div id="edit-dialog" class="typecho-dialog" style="display:none;">
                        <h3><?php _e('编辑会员'); ?></h3>
                        <form action="<?php $security->index('/action/members-edit?do=editMember'); ?>" method="post">
                            <ul class="typecho-option">
                                <li>
                                    <label class="typecho-label" for="edit-expire-time"><?php _e('到期时间'); ?></label>
                                    <input type="date" id="edit-expire-time" name="expire_time" class="w-100 text" required/>
                                </li>
                                <li>
                                    <button type="submit" class="btn primary"><?php _e('保存'); ?></button>
                                    <button type="button" class="btn cancel"><?php _e('取消'); ?></button>
                                </li>
                            </ul>
                            <input type="hidden" name="uid" id="edit-uid"/>
                            <?php $security->nonce(); ?>
                        </form>
                    </div>

                    <style>
                    .btn-edit, .btn-delete {
                        margin-right: 8px;
                        color: #3b82f6;
                        text-decoration: none;
                    }
                    .btn-delete {
                        color: #ef4444;
                    }
                    .status {
                        padding: 2px 8px;
                        border-radius: 4px;
                        font-size: 12px;
                    }
                    .status.active {
                        background: #dcfce7;
                        color: #16a34a;
                    }
                    .status.expired {
                        background: #fee2e2;
                        color: #dc2626;
                    }
                    #edit-dialog {
                        position: fixed;
                        top: 50%;
                        left: 50%;
                        transform: translate(-50%, -50%);
                        background: #fff;
                        padding: 24px;
                        border-radius: 8px;
                        box-shadow: 0 4px 24px rgba(0, 0, 0, 0.1);
                        z-index: 1000;
                        min-width: 320px;
                    }
                    #edit-dialog h3 {
                        margin: 0 0 16px 0;
                        font-size: 18px;
                        color: #1f2937;
                    }
                    #edit-dialog .typecho-option li {
                        margin: 0 0 16px 0;
                    }
                    #edit-dialog .btn {
                        margin-right: 8px;
                    }
                    #edit-dialog .cancel {
                        background: #f3f4f6;
                        color: #4b5563;
                    }
                    .dialog-mask {
                        position: fixed;
                        top: 0;
                        left: 0;
                        right: 0;
                        bottom: 0;
                        background: rgba(0, 0, 0, 0.5);
                        z-index: 999;
                    }
                    /* 深色模式 */
                    @media (prefers-color-scheme: dark) {
                        #edit-dialog {
                            background: #1f2937;
                        }
                        
                        #edit-dialog h3 {
                            color: #f3f4f6;
                        }
                        
                        #edit-dialog .cancel {
                            background: #374151;
                            color: #9ca3af;
                        }
                    }
                    </style>

                    <script>
                    document.getElementById('btn-add-member').addEventListener('click', function(e) {
                        e.preventDefault();
                        var form = document.getElementById('form-add-member');
                        form.style.display = form.style.display === 'none' ? 'block' : 'none';
                    });

                    // 设置日期选择器的默认值和最小值
                    var today = new Date().toISOString().split('T')[0];
                    var startTimeInput = document.getElementById('start-time');
                    var expireTimeInput = document.getElementById('expire-time');

                    startTimeInput.value = today;
                    startTimeInput.min = today;
                    expireTimeInput.min = today;

                    // 确保到期时间不能早于开始时间
                    startTimeInput.addEventListener('change', function() {
                        expireTimeInput.min = this.value;
                        if (expireTimeInput.value && expireTimeInput.value < this.value) {
                            expireTimeInput.value = this.value;
                        }
                    });

                    // 表单提交前验证
                    document.querySelector('#form-add-member form').addEventListener('submit', function(e) {
                        var uid = document.getElementById('user-select').value;
                        var expireTime = document.getElementById('expire-time').value;
                        
                        if (!uid || !expireTime) {
                            e.preventDefault();
                            alert('请填写完整信息');
                        }
                    });

                    // 编辑功能
                    document.querySelectorAll('.btn-edit').forEach(function(btn) {
                        btn.addEventListener('click', function(e) {
                            e.preventDefault();
                            var uid = this.dataset.uid;
                            var expireTime = this.closest('tr').querySelector('.edit-expire-time').textContent.trim();
                            
                            // 显示遮罩
                            var mask = document.createElement('div');
                            mask.className = 'dialog-mask';
                            document.body.appendChild(mask);
                            
                            // 显示编辑弹窗
                            var dialog = document.getElementById('edit-dialog');
                            dialog.style.display = 'block';
                            
                            // 设置表单数据
                            document.getElementById('edit-uid').value = uid;
                            document.getElementById('edit-expire-time').value = expireTime;
                            
                            // 取消按钮事件
                            dialog.querySelector('.cancel').onclick = function() {
                                dialog.style.display = 'none';
                                mask.remove();
                            };
                            
                            // 点击遮罩关闭
                            mask.onclick = function() {
                                dialog.style.display = 'none';
                                mask.remove();
                            };
                        });
                    });
                    </script>
                </div>
            </div>
        </div>
    </div>
</div>

<?php
include 'footer.php';
?> 